<template>
  <div>
    <crumbs title="医院管理" style="min-width: 960px">
      <el-form :inline="true" class="demo-form-inline">
        <el-form-item label="医院名称：" class="selectMedicine">
          <el-select size="mini" v-model="filter.hospitalName" placeholder="请选择" clearable>
            <el-option
              v-for="item in HospitalInfoList"
              :label="item.name"
              :value="item.name"
              :key="item.id"
            ></el-option>
          </el-select>
        </el-form-item>

        <el-form-item class="dododo">
          <el-button size="mini" @click="filterDatas">检索</el-button>
          <el-button size="mini" type="warning" @click="addRelation">添加医院</el-button>
        </el-form-item>
      </el-form>
    </crumbs>
    <div class="contents">
      <el-table :data="list" border style="width: 100%">
        <el-table-column :resizable="false" type="index" :index="indexMethod" label="编号" width="60"></el-table-column>
        <!-- <el-table-column :resizable="false" prop="code" label="医院编码" width="180"></el-table-column> -->
        <el-table-column :resizable="false" prop="name" label="医院名称" show-overflow-tooltip></el-table-column>
        <el-table-column :resizable="false" prop="spell" label="医院名称拼音" show-overflow-tooltip></el-table-column>
        <el-table-column :resizable="false" prop="address" label="医院地址" show-overflow-tooltip></el-table-column>
        <el-table-column :resizable="false" prop="gmtCreate" label="创建时间" show-overflow-tooltip></el-table-column>
        <el-table-column
          :resizable="false"
          prop="status"
          label="状态"
          show-overflow-tooltip
          width="180"
        >
          <template slot-scope="scope">{{scope.row.status == 1 ? '已启用': '已禁用'}}</template>
        </el-table-column>
        <el-table-column :resizable="false" prop="operate" label="操作">
          <template slot-scope="scope">
            <el-button @click="modifyRelation(scope.row)" type="text" size="small">修改</el-button>
            <span style="margin:0 3px;">|</span>
            <el-button
              @click="startOrEndHos(scope.row,'start')"
              type="text"
              size="small"
              v-if="scope.row.status === 0"
            >启用</el-button>
            <el-button
              @click="startOrEndHos(scope.row,'end')"
              class="delete"
              type="text"
              size="small"
              v-if="scope.row.status === 1"
            >禁用</el-button>
            <span style="margin:0 3px;">|</span>
            <el-button @click="showDelDialog(scope.row)" class="delete" type="text" size="small">删除</el-button>
          </template>
        </el-table-column>
      </el-table>
      <div class="pagination pagepage">
        <el-pagination
          :current-page.sync="currentPage"
          @current-change="currentChange"
          background
          :page-size="pageSize"
          :page-sizes="pageSizeArr"
          @size-change="handleSizeChange"
          :layout="pageLayout"
          :total="total"
        ></el-pagination>
      </div>
    </div>
  </div>
</template>

<script>
import api from '@api/cdss.js';
import config from '@api/config.js';
import utils from '@api/utils.js';

export default {
  name: 'HospitalCDSS',
  data: function() {
    return {
      list: [],
      searched: false,
      filter: {
        hospitalName: '' // 医院名称
      },
      currentPage: 1,
      pageSize: config.pageSize,
      pageSizeArr: config.pageSizeArr,
      pageLayout: config.pageLayout,
      total: 0,
      HospitalInfoList: []
    };
  },
  created() {
    const that = this;
    //返回时避免参数未赋值就获取列表
    setTimeout(function() {
      that.getDataList();
    });
    // 非首页 编辑页返回 设置 this.currentPage
    if (Object.keys(this.$route.params).length !== 0) {
      this.currentPage = this.$route.params.currentPage;
    }

    this._getHospitalInfo();
  },
  watch: {
    filter: {
      handler: function() {
        this.searched = false;
      },
      deep: true
    }
  },
  beforeRouteEnter(to, from, next) {
    next(vm => {
      //const pm = to.param;
      Object.assign(vm, to.params);
      vm.inCurrentPage = to.params.currentPage;
    });
  },
  methods: {
    handleSizeChange(val) {
      this.pageSize = val;
      this.currentPage = utils.getCurrentPage(
        this.currentPage,
        this.total,
        this.pageSize
      );
      this.getDataList();
    },

    // 启用/禁用医院
    startOrEndHos(row, type) {
      let msg = '';
      let status = 1;
      if (type === 'start') {
        msg = `确定要启用${row.name}吗？`;
        status = 1;
      } else {
        msg = `确定要禁用${row.name}吗？`;
        status = 0;
      }

      this.$alert(msg, '提示', {
        confirmButtonText: '确定',
        type: 'warning'
      })
        .then(() => {
          api
            .changeStatusCDSS({
              id: row.id,
              status: status
            })
            .then(res => {
              if (res.data.code === '0') {
                this.getDataList();
                this.$message({
                  showClose: true,
                  message: '保存成功',
                  type: 'success',
                  duration: 1000
                });
              }
            });
        })
        .catch(() => {});
    },

    // 获取列表数据
    getDataList(isTurnPage) {
      const params = this.getFilterItems(isTurnPage);
      this.searched = true;
      const loading = this.$loading({
        lock: true,
        text: 'Loading',
        spinner: 'el-icon-loading',
        background: 'rgba(0, 0, 0, 0.7)'
      });
      api.getHospitalPageCDSS(params).then(res => {
        loading.close();
        if (res.data.code === '0') {
          this.list = res.data.data && res.data.data.records;
        }
        this.total = res.data.data && res.data.data.total;
        if (this.inCurrentPage !== undefined) {
          this.currentPage = this.inCurrentPage;
          this.inCurrentPage = undefined;
        }
      });
    },

    // 处理列表请求数据参数
    getFilterItems(isTurnPage) {
      const { data } = this.$route.params;
      //翻页时筛选条件没点确定则清空
      if (isTurnPage && !this.searched) {
        this.clearFilter();
      }
      const param = {
        current: this.inCurrentPage || this.currentPage,
        size: this.pageSize,
        name: this.filter.hospitalName.trim()
      };
      return param;
    },

    // 获取医院下拉列表
    _getHospitalInfo() {
      api.getHospitalInfo().then(res => {
        if (res.data.code === '0') {
          this.HospitalInfoList = res.data.data;
        }
      });
    },

    filterDatas() {
      this.currentPage = 1;
      this.getDataList();
    },
    addRelation() {
      const pam = this.searched
        ? {
            currentPage: this.currentPage,
            pageSize: this.pageSize,
            filter: this.filter
          }
        : { currentPage: this.currentPage, pageSize: this.pageSize };
      this.$router.push({
        name: 'AddHospitalCDSS',
        params: Object.assign(pam, {
          isEdit: false
        })
      });
    },
    // 修改诊断关联-跳转至编辑页面
    modifyRelation(row) {
      const item = Object.assign({}, row);
      const pam = this.searched
        ? {
            currentPage: this.currentPage,
            pageSize: this.pageSize,
            filter: this.filter
          }
        : { currentPage: this.currentPage, pageSize: this.pageSize };
      this.$router.push({
        name: 'AddHospitalCDSS',
        params: Object.assign(pam, {
          isEdit: true,
          data: { ...item }
          // hospitaiName: this.hospitaiName
        })
      });
    },
    currentChange(next) {
      this.currentPage = next;
      this.getDataList(true);
    },
    // 清空搜索参数
    clearFilter() {
      this.filter = {
        hospitalName: ''
      };
    },

    indexMethod(index) {
      return (this.currentPage - 1) * this.pageSize + index + 1;
    },
    getTagType(val) {
      return val;
    },
    warning(msg, type) {
      this.$message({
        showClose: true,
        message: msg,
        type: type || 'warning'
      });
    },
    showConfirmDialog(msg, resolve) {
      this.$alert(msg, '提示', {
        confirmButtonText: '删除',
        // cancelButtonText: '取消',
        // cancelButtonClass: 'cancelBtn',
        // confirmButtonClass: 'confirmC',
        type: 'warning'
      })
        .then(() => {
          resolve();
        })
        .catch(() => {});
    },
    // 删除关联
    showDelDialog(row) {
      // console.log(row); return 
      this.showConfirmDialog(`医院删除后无法恢复，确定要删除${row.name}吗？`, () => {
        api
          .deleteHosRecordCDSS({ id: row.id })
          .then(res => {
            // console.log(res, '=============');
            if (res.data.code == '0') {
              if (!this.searched) {
                //未点确认时清空搜索条件
                this.clearFilter();
              }
              if (this.list.length == 1) {
                //当前在最后一页且只有一条数据时，删除后跳到前一页
                this.currentPage =
                  this.currentPage === 1 ? 1 : this.currentPage - 1;
              }
              this.getDataList();
              this._getHospitalInfo();  // 更新下拉列表
              this.warning(res.data.msg || '操作成功', 'success');
            } else {
              this.warning(res.data.msg);
            }
          })
          .catch(error => {
            if (error.code === '900010001') {
              return false;
            }
            this.warning(error);
          });
      });
    }
  }
};
</script>


<style lang="less" scoped>
@import '../../../less/admin.less';
.delete {
  color: red;
}
.delete:hover {
  color: red;
}
.pagination {
  min-width: 1010px;
}
.downTemplate {
  margin-right: 8px;
  span {
    color: #02a7f0;
  }
}
#upFile {
  display: none !important;
}
.el-message-box {
  /deep/.cancelBtn {
    background-color: #d7d7d7;
    border-color: transparent;
  }
  /deep/.confirmC {
    background-color: #ff545b !important;
    border-color: transparent !important;
  }
}
.exportBox6 {
  /deep/ .el-message-box__btns {
    margin-top: 20px;
  }
  /deep/ .el-message-box__message {
    // text-align: center;
  }
  /deep/.leftbtn {
    background-color: #d7d7d7;
    border-color: transparent !important;
  }
  /deep/ .el-message-box__header {
    border-bottom: 1px solid #dcdfe6;
  }
}
</style>